#! /bin/bash
# $1 - exp data file
# $2 - output dir

set -x

LANG=en_US

for dataset in "ai10-2011" "ai10-2013" "ijcai-2013"
do
    for algo in "cautious_atomizing" "cautious_extract" "conservative_extract"
    do
	for merge in "halldor" "greedy_maxdeg" "greedy_mindeg" "maximum"
	do
	    for comp in $(seq 0.1 0.1 0.9)
	    do
		for cite in "sum_cite" "union_cite"
		do
		    outfile="$2/$dataset/"$cite"_"$algo"_"$merge
		    echo "author,comp,initial_hindex,max_hindex,k" > $outfile
		    grep -e $dataset -e $algo -e $merge -e $comp -e $cite $1 | cut -d ' ' -f 2,3,7,8,10 | tr ' ' ',' >> $outfile
		done
	    done
	done
    done
done

	       
